
/* ****************************************************************** */
/** Bibliotheque libList
 * 
 * Auteur : J.Paul Schmidt.
 * Version : 1.1            date : 88/04/14
 * 
 * Modifications : 
 * Auteur : 
 * Reason : 
 * Implemented functionality : Lists handler.
 *
 Interface functions : CreatList
 *                     AddElmList
 *                     AppendList
 *                     CopyList
 *                     CreatList
 *                     DestElmList
 *                     DestList
 *                     ElmNumList
 *                     <PrintList> (pour traces)
 *                     InsertSortList
 *                     EmptyList
 *                     MapList
 *                     FirstElmList
 *                     NextElmList
 *                     SizeList 
 *                     SortList
 **/  
/* ****************************************************************** */

#ifndef _EngListeP 
#define _EngListeP
#include <stdio.h>

/* List node */
typedef struct _st_elem
 {
  long   s_elem ;             /* List element */
  struct _st_elem *p_suiv ;   /* Next element */
  } ty_node ;


/* List */
typedef struct 
 {
  ty_node *p_first ;          /* First node */
  ty_node *p_cur ;            /* Curent node */
  ty_node *p_last ;           /* Last node */
  long num ;                  /* # of elm in the list */
 } ty_list ;

/* Constantes */
#define ERRVI -999999990
#define ERRNU -999999991
#define PASERR 0

/* Macros */
#ifdef debug

#define Lst_TestPar(ptr, mess, err)  \
   { if (ptr == NULL) { \
       fprintf(stderr, mess) ; \
       fprintf(stderr, "file : %s, line : %d \n", __FILE__, __LINE__) ; \
       return (err) ; \
     } ; /* end of the if (ptr == NULL) */ \
   }

#else 

#define Lst_TestPar(ptr, mess, err)   { if (ptr == NULL) return (err) ;}

#endif

/* type */
typedef long Liste ;
#endif
